<template>
  <el-container class="pokemons" v-loading="isLoading">
    <el-main>
        <el-row :gutter="20">
          <el-col :span="3" v-for="pokemon in pokemons" :key="pokemon.name">
            <el-card shadow="hover" :body-style="{ padding: 0 }">
              <div class="pokemon-container" @click="onPokemonClick(pokemon)">
                <img :src="imageUrl(pokemon)" class="image">
                <p>{{pokemon.name | capitalize}}</p>
              </div>
            </el-card>
          </el-col>
        </el-row>
    </el-main>
    <el-footer>
      <el-pagination
              layout="prev, pager, next"
              :page-size="50"
              :total="pokemonsCount"
              :current-page.sync="currentPaginationPage"
              :disabled="isLoading"
              @current-change="handlePaginationChange">
      </el-pagination>
    </el-footer>
  </el-container>
</template>

<script>
import { mapState } from 'vuex';
import { mapGetters } from 'vuex';

export default {
  name: 'pokemons',
  data() {
    return {
      isLoading: false,
      currentPaginationPage: 1,
    }
  },
  methods: {
    handlePaginationChange(val) {
      this.loadPokemons(this.currentPaginationPage);
      this.$router.push({ name: 'pokemons', params: { page: val }});
    },
    onPokemonClick(pokemon) {
      this.$router.push({ name: 'pokemonDetail', params: { name: pokemon.name }});
    },
    imageUrl(pokemon) {
      return pokemon.sprites.front_default;
    },
    loadPokemons(forPage) {
      this.isLoading = true;

      return this.$store.dispatch('getPokemons', {
        limit: 50,
        offset: 50 * (forPage - 1)
      }).then(() => {
        this.isLoading = false;
      });
    }
  },
  computed: {
    ...mapState([
      'pokemons'
    ]),
    ...mapGetters([
      'pokemonsCount'
    ])
  },
  mounted() {
    let page = Number(this.$router.currentRoute.params.page);

    this.loadPokemons(page).then(() => {
      this.currentPaginationPage = page;
    });
  }
}

</script>

<style lang="scss">

.pokemons {
  height: 100%;
}

.el-col {
  margin-bottom: 20px;
}

.el-card {
  padding: 0;
  border-color: #f3f4f7 !important;
  height: 170px;

  .pokemon-container {
    padding: 20px 0 20px 0;

    img {
      height: 110px;
      width: 110px;
      margin: -5px;
    }

    p {
      font-size: 1.15em;
      margin: 0;
    }
  }
}

.el-pagination {
  margin-top: 15px;
}

.el-loading-mask {
  bottom: 60px !important;
}

</style>
